## soprano 2.8.0+dfsg.1

=== CMakeLists.txt ===
project(soprano)

cmake_minimum_required(VERSION 2.6.4)
# disable warning about shadowing CMakeParseArguments.cmake
if(POLICY CMP0017)
  cmake_policy(SET CMP0017 NEW)
endif(POLICY CMP0017)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

include(CTest)
include(CTestConfig.cmake)

##################  Soprano version  ################################
set(CMAKE_SOPRANO_VERSION_MAJOR 2)
set(CMAKE_SOPRANO_VERSION_MINOR 8)
set(CMAKE_SOPRANO_VERSION_RELEASE 0)
set(CMAKE_SOPRANO_VERSION_STRING "${CMAKE_SOPRANO_VERSION_MAJOR}.${CMAKE_SOPRANO_VERSION_MINOR}.${CMAKE_SOPRANO_VERSION_RELEASE}")


##################  User options  ################################

option(SOPRANO_BUILD_TESTS "Build all unit tests")
option(SOPRANO_DISABLE_REDLAND_BACKEND "Disable compilation of Redland storage backend")
option(SOPRANO_DISABLE_SESAME2_BACKEND "Disable compilation of Sesame2 storage backend")
option(SOPRANO_DISABLE_VIRTUOSO_BACKEND "Disable compilation of Virtuoso storage backend")
option(SOPRANO_DISABLE_CLUCENE_INDEX "Disable compilation of Clucene-based full-text index")
option(SOPRANO_DISABLE_RAPTOR_PARSER "Disable compilation of Raptor parser plugin")
option(SOPRANO_DISABLE_RAPTOR_SERIALIZER "Disable compilation of Raptor RDF serializer plugin")
option(SOPRANO_DISABLE_DBUS "Disable D-Bus integration")
option(SOPRANO_BUILD_API_DOCS "Build Soprano API documentation")

if(SOPRANO_BUILD_TESTS)
  enable_testing()
endif(SOPRANO_BUILD_TESTS)

if(WIN32)
  set(CMAKE_DEBUG_POSTFIX "d")
endif(WIN32)

include(SopranoCPack.cmake)

##################  find packages  ################################

set(QT_MIN_VERSION "4.5.0")
find_package(Qt4 REQUIRED)
# properly set up compile flags (QT_DEBUG/QT_NO_DEBUG, ...)
include(${QT_USE_FILE})

if(NOT SOPRANO_DISABLE_RAPTOR_PARSER OR NOT SOPRANO_DISABLE_RAPTOR_SERIALIZER OR NOT SOPRANO_DISABLE_REDLAND_BACKEND)
  find_package(Rasqal)
  find_package(Raptor 2.0.0)
  find_package(Redland)

  if(WIN32)
    if(NOT REDLAND_VERSION)
      set(REDLAND_VERSION "1.0.3")
      message(STATUS "Windows currently only has Redland version 1.0.3")
    endif(NOT REDLAND_VERSION)
  endif(WIN32)
endif(NOT SOPRANO_DISABLE_RAPTOR_PARSER OR NOT SOPRANO_DISABLE_RAPTOR_SERIALIZER OR NOT SOPRANO_DISABLE_REDLAND_BACKEND)

if(NOT SOPRANO_DISABLE_CLUCENE_INDEX)
  find_package(CLucene)
  if(CLucene_FOUND)
    if(CLUCENE_VERSION AND CLUCENE_VERSION VERSION_GREATER "0.9.19" OR CLUCENE_VERSION VERSION_EQUAL "0.9.19")
      set(CL_VERSION_19_OR_GREATER TRUE)
    endif(CLUCENE_VERSION AND CLUCENE_VERSION VERSION_GREATER "0.9.19" OR CLUCENE_VERSION VERSION_EQUAL "0.9.19")
    set(SOPRANO_BUILD_INDEX_LIB 1 CACHE INTERNAL "Soprano Index is built" FORCE)
  endif(CLucene_FOUND)
endif(NOT SOPRANO_DISABLE_CLUCENE_INDEX)

if(NOT SOPRANO_DISABLE_SESAME2_BACKEND)
  find_package(JNI)
  if(JAVA_INCLUDE_PATH AND JAVA_JVM_LIBRARY)
    file(READ ${JAVA_INCLUDE_PATH}/jni.h jni_header_data)
    string(REGEX MATCH "JNI_VERSION_1_4" JNI_1_4_FOUND "${jni_header_data}")
    if(JNI_1_4_FOUND)
      message(STATUS "Found Java JNI >= 1.4: ${JAVA_INCLUDE_PATH}, ${JAVA_JVM_LIBRARY}")
    else(JNI_1_4_FOUND)
      message( "Need JNI version 1.4 or higher for the Sesame2 backend.")
    endif(JNI_1_4_FOUND)
  else(JAVA_INCLUDE_PATH AND JAVA_JVM_LIBRARY)
    message(STATUS "Could not find Java JNI")
    if("$ENV{JAVA_HOME}" STREQUAL "")
      message("Make sure JAVA_HOME is set")
    endif("$ENV{JAVA_HOME}" STREQUAL "")
  endif(JAVA_INCLUDE_PATH AND JAVA_JVM_LIBRARY)
endif(NOT SOPRANO_DISABLE_SESAME2_BACKEND)

if(NOT SOPRANO_DISABLE_VIRTUOSO_BACKEND)
if(WIN32)
  include(CheckIncludeFiles)
  check_include_files("windows.h;sql.h" HAVE_SQL_H)
else(WIN32)
  find_package(IODBC)
endif(WIN32)
endif(NOT SOPRANO_DISABLE_VIRTUOSO_BACKEND)


##################  setup variables  ################################
if(REDLAND_FOUND)
   macro_ensure_version( "1.0.5" ${REDLAND_VERSION} REDLAND_VERSION_GOOD )
endif(REDLAND_FOUND)

if(REDLAND_FOUND AND NOT SOPRANO_DISABLE_REDLAND_BACKEND)
  set(BUILD_REDLAND_BACKEND TRUE)
endif(REDLAND_FOUND AND NOT SOPRANO_DISABLE_REDLAND_BACKEND)
if(JNI_1_4_FOUND AND NOT SOPRANO_DISABLE_SESAME2_BACKEND)
  set(BUILD_SESAME2_BACKEND TRUE)
endif(JNI_1_4_FOUND AND NOT SOPRANO_DISABLE_SESAME2_BACKEND)
if(SOPRANO_BUILD_INDEX_LIB AND NOT SOPRANO_DISABLE_CLUCENE_INDEX)
  set(BUILD_CLUCENE_INDEX TRUE)
endif(SOPRANO_BUILD_INDEX_LIB AND NOT SOPRANO_DISABLE_CLUCENE_INDEX)
if(RAPTOR_FOUND AND NOT SOPRANO_DISABLE_RAPTOR_PARSER)
  set(BUILD_RAPTOR_PARSER TRUE)
endif(RAPTOR_FOUND AND NOT SOPRANO_DISABLE_RAPTOR_PARSER)
if(RAPTOR_FOUND AND NOT SOPRANO_DISABLE_RAPTOR_SERIALIZER)
  set(BUILD_RAPTOR_SERIALIZER TRUE)
endif(RAPTOR_FOUND AND NOT SOPRANO_DISABLE_RAPTOR_SERIALIZER)
if(NOT SOPRANO_DISABLE_DBUS AND QT_QTDBUS_FOUND)
  set(BUILD_DBUS_SUPPORT TRUE)
endif(NOT SOPRANO_DISABLE_DBUS AND QT_QTDBUS_FOUND)
if(NOT SOPRANO_DISABLE_VIRTUOSO_BACKEND)
  if(IODBC_FOUND OR HAVE_SQL_H)
    set(BUILD_VIRTUOSO_BACKEND TRUE)
  endif(IODBC_FOUND OR HAVE_SQL_H)
endif(NOT SOPRANO_DISABLE_VIRTUOSO_BACKEND)
set(HAVE_DBUS BUILD_DBUS_SUPPORT)

##################  setup install directories  ################################
set (LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )
set (LIB_DESTINATION "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE STRING "Library directory name")
## the following are directories where stuff will be installed to
set(INCLUDE_INSTALL_DIR      "${CMAKE_INSTALL_PREFIX}/include/" CACHE PATH "The subdirectory to the header prefix")
set(PKGCONFIG_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/pkgconfig/" CACHE STRING "Base directory for pkgconfig files")


# Set up RPATH handling, so the libs are found if they are installed to a non-standard location.
# By default cmake builds the targets with full RPATH to everything in the build directory,
# but then removes the RPATH when installing.
# These two options below make it set the RPATH of the installed targets to all
# RPATH directories outside the current CMAKE_BINARY_DIR and also the library
# install directory. Alex
list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${LIB_DESTINATION}" _isSystemPlatformLibDir)
list(FIND CMAKE_C_IMPLICIT_LINK_DIRECTORIES "${LIB_DESTINATION}" _isSystemCLibDir)
list(FIND CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES "${LIB_DESTINATION}" _isSystemCxxLibDir)
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH  TRUE)
if("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")
set(CMAKE_INSTALL_RPATH                ${LIB_DESTINATION} )
endif("${_isSystemPlatformLibDir}" STREQUAL "-1" AND "${_isSystemCLibDir}" STREQUAL "-1" AND "${_isSystemCxxLibDir}" STREQUAL "-1")

if(APPLE)
   set(CMAKE_INSTALL_NAME_DIR ${LIB_DESTINATION})
endif(APPLE)


##################  some compiler settings ################################
if(CMAKE_COMPILER_IS_GNUCXX AND NOT WIN32 )
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -ansi -Wundef -Wcast-align -Wchar-subscripts -Wall -W -Wpointer-arith -Wformat-security -fno-check-new -fno-common")
    include(CheckCXXCompilerFlag)
    check_cxx_compiler_flag(-fvisibility=hidden __SOPRANO_HAVE_GCC_VISIBILITY)
    check_cxx_compiler_flag(-fvisibility-inlines-hidden __SOPRANO_HAVE_GCC_INLINE_VISIBILITY)
    if(__SOPRANO_HAVE_GCC_VISIBILITY)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility=hidden")
    endif(__SOPRANO_HAVE_GCC_VISIBILITY)
    if(__SOPRANO_HAVE_GCC_INLINE_VISIBILITY)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
    endif(__SOPRANO_HAVE_GCC_INLINE_VISIBILITY)
endif(CMAKE_COMPILER_IS_GNUCXX AND NOT WIN32 )
if(MSVC)
    add_definitions(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -Zc:wchar_t-)
endif(MSVC)
if(MINGW)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wnon-virtual-dtor -Wno-long-long -ansi -Wundef -Wcast-align -Wchar-subscripts -Wall -Wpointer-arith -Wformat-security -fno-check-new -fno-common")
endif(MINGW)

if(WINCE)
  set(LIBRARY_TYPE STATIC)
  add_definitions(-DSOPRANO_STATIC_LIBS)
else(WINCE)
  set(LIBRARY_TYPE SHARED)
endif(WINCE)

# Soprano will handle large files in LockFile (Virtuoso DB files)
add_definitions(-D_FILE_OFFSET_BITS=64)


##################  add subdirectories ################################
if(BUILD_CLUCENE_INDEX)
   add_subdirectory(index)
endif(BUILD_CLUCENE_INDEX)
add_subdirectory(soprano)
add_subdirectory(backends)
add_subdirectory(parsers)
add_subdirectory(serializers)
add_subdirectory(server)
add_subdirectory(client)
add_subdirectory(tools)
add_subdirectory(rules)
add_subdirectory(includes)
if(SOPRANO_BUILD_TESTS)
  add_subdirectory(test)
endif(SOPRANO_BUILD_TESTS)
add_subdirectory(cmake)


##################  create pkgconfig files  ################################
if(NOT WIN32)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/soprano.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/soprano.pc @ONLY)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/sopranoclient.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/sopranoclient.pc @ONLY)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/sopranoserver.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/sopranoserver.pc @ONLY)

  install(
    FILES
    ${CMAKE_CURRENT_BINARY_DIR}/soprano.pc
    ${CMAKE_CURRENT_BINARY_DIR}/sopranoclient.pc
    ${CMAKE_CURRENT_BINARY_DIR}/sopranoserver.pc
    DESTINATION
    ${PKGCONFIG_INSTALL_PREFIX})

  if(BUILD_CLUCENE_INDEX)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/sopranoindex.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/sopranoindex.pc @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/sopranoindex.pc DESTINATION ${PKGCONFIG_INSTALL_PREFIX})
  endif(BUILD_CLUCENE_INDEX)
endif(NOT WIN32)


##################  apidox ################################
find_package(Doxygen)

if(DOXYGEN_EXECUTABLE)
  set(QTDOCS_ONLINE "http://qt-project.org/doc/qt-4.8/")

  if(EXISTS ${QT_DOC_DIR}/html)
    set(QTDOCS_LOCAL "${QT_DOC_DIR}/html")
  else(EXISTS ${QT_DOC_DIR}/html)
    set(QTDOCS_LOCAL ${QTDOCS_ONLINE})
  endif(EXISTS ${QT_DOC_DIR}/html)

  set(QTDOCS ${QTDOCS_LOCAL})
  configure_file(${soprano_SOURCE_DIR}/Doxyfile.cmake ${soprano_BINARY_DIR}/Doxyfile.local)

  set(QTDOCS ${QTDOCS_ONLINE})
  configure_file(${soprano_SOURCE_DIR}/Doxyfile.cmake ${soprano_BINARY_DIR}/Doxyfile.online)

  if(SOPRANO_BUILD_API_DOCS)
    add_custom_target(
      apidox ALL
      COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile.local
      COMMENT "Building Soprano API docs...")
  else(SOPRANO_BUILD_API_DOCS)
    add_custom_target(
      apidox
      COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile.local
      COMMENT "Building Soprano API docs...")
  endif(SOPRANO_BUILD_API_DOCS)

  add_custom_target(
    onlineapidox
    COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile.online
    COMMENT "Building Soprano API docs...")

  add_custom_target(
    stabledox
    COMMAND rsync -zrtq docs/html/ $ENV{USER},soprano@web.sf.net:/home/project-web/soprano/htdocs/apidox/stable
    DEPENDS onlineapidox
    COMMENT "Uploading stable API docs to Sourceforge...")

  add_custom_target(
    trunkdox
    COMMAND rsync -zrtq docs/html/ $ENV{USER},soprano@web.sf.net:/home/project-web/soprano/htdocs/apidox/trunk
    DEPENDS onlineapidox
    COMMENT "Uploading trunk API docs to Sourceforge...")
endif(DOXYGEN_EXECUTABLE)


##################  status messages ################################
message("---------------------------------------------------------------------------------------")
message("-- Soprano Components that will be built:")
if(NOT BUILD_REDLAND_BACKEND AND NOT BUILD_SESAME2_BACKEND AND NOT BUILD_VIRTUOSO_BACKEND)
  message("   WARNING: No Soprano backends will be compiled!")
  message("   WARNING: Soprano will not be very useful without storage backends!")
endif(NOT BUILD_REDLAND_BACKEND AND NOT BUILD_SESAME2_BACKEND AND NOT BUILD_VIRTUOSO_BACKEND)
if(BUILD_REDLAND_BACKEND)
  message("   * Redland storage backend")
endif(BUILD_REDLAND_BACKEND)
if(BUILD_SESAME2_BACKEND)

=== client/CMakeLists.txt ===
project(soprano_client)

include_directories(
  ${soprano_client_BINARY_DIR}
  ${soprano_server_SOURCE_DIR}
  ${soprano_server_dbus_SOURCE_DIR}
  ${soprano_core_SOURCE_DIR}
  ${soprano_core_BINARY_DIR}
  ${soprano_core_SOURCE_DIR}/util
  ${soprano_core_SOURCE_DIR}/query
  ${soprano_core_SOURCE_DIR}/vocabulary
  ${QT_INCLUDES}
  ${soprano_SOURCE_DIR}
)

set(soprano_client_SRC
  ${soprano_server_SOURCE_DIR}/datastream.cpp
  tcpclient.cpp
  socket.cpp
  socketstream.cpp
  localsocketclient.cpp
  clientconnection.h
  clientconnection.cpp
  clientmodel.cpp
  clientstatementiteratorbackend.cpp
  clientnodeiteratorbackend.cpp
  clientqueryresultiteratorbackend.cpp
)

if(NOT WINCE)
  set(soprano_client_SRC
    ${soprano_client_SRC}
    sparql/sparqlmodel.cpp
    sparql/sparqlqueryresult.cpp
    sparql/sparqlprotocol.cpp
    sparql/sparqlxmlresultparser.cpp
    )
endif(NOT WINCE)

if(BUILD_DBUS_SUPPORT)
  set(soprano_client_SRC
    ${soprano_client_SRC}
    ${soprano_server_SOURCE_DIR}/dbus/dbusutil.cpp
    ${soprano_server_SOURCE_DIR}/dbus/dbusoperators.cpp
    dbus/dbusabstractinterface.cpp
    dbus/dbusmodelinterface.cpp
    dbus/dbusstatementiteratorinterface.cpp
    dbus/dbusnodeiteratorinterface.cpp
    dbus/dbusqueryresultiteratorinterface.cpp
    dbus/dbusserverinterface.cpp
    dbus/dbusclient.cpp
    dbus/dbusmodel.cpp
    dbus/dbusclientnodeiteratorbackend.cpp
    dbus/dbusclientstatementiteratorbackend.cpp
    dbus/dbusclientqueryresultiteratorbackend.cpp
    dbus/dbusstatementiterator.cpp
    dbus/dbusnodeiterator.cpp
    dbus/dbusqueryresultiterator.cpp
    )
endif(BUILD_DBUS_SUPPORT)

qt4_automoc(${soprano_client_SRC})

add_library(sopranoclient ${LIBRARY_TYPE} ${soprano_client_SRC})

set_target_properties(sopranoclient PROPERTIES
  VERSION 1.2.0
  SOVERSION 1
  DEFINE_SYMBOL MAKE_SOPRANO_CLIENT_LIB
  INSTALL_NAME_DIR ${LIB_DESTINATION}
)

target_link_libraries(
  sopranoclient
  ${QT_QTCORE_LIBRARY}
  ${QT_QTNETWORK_LIBRARY}
  ${QT_QTXML_LIBRARY}
  soprano
)

if(WIN32)
   target_link_libraries(sopranoclient ws2_32)
endif(WIN32)

if(BUILD_DBUS_SUPPORT)
  target_link_libraries(
    sopranoclient
    ${QT_QTDBUS_LIBRARY})
endif(BUILD_DBUS_SUPPORT)

INSTALL(TARGETS sopranoclient
	LIBRARY DESTINATION ${LIB_DESTINATION}
	RUNTIME DESTINATION bin
	ARCHIVE DESTINATION lib
)

install(
  FILES 
  tcpclient.h
  localsocketclient.h
  DESTINATION include/soprano
)

add_subdirectory(sparql)
if(BUILD_DBUS_SUPPORT)
  add_subdirectory(dbus)
endif(BUILD_DBUS_SUPPORT)

=== debian/changelog ===
soprano (2.8.0+dfsg.1-0ubuntu1) quantal; urgency=low

  * New upstream release (LP: #1018300).
  * Bump Standards-Version to 3.9.3.

 -- Logan Rosen <logatronico@gmail.com>  Mon, 02 Jul 2012 17:05:06 -0400

soprano (2.7.57+dfsg.1-0ubuntu3) quantal; urgency=low

  * Install tcpclient.h to libsoprano-dev, required by smokekde.

 -- Felix Geyer <debfx@ubuntu.com>  Wed, 13 Jun 2012 08:59:26 +0200

soprano (2.7.57+dfsg.1-0ubuntu2) quantal; urgency=low

  * Update symbols files on all archs

 -- Scott Kitterman <scott@kitterman.com>  Tue, 12 Jun 2012 22:49:32 -0400

soprano (2.7.57+dfsg.1-0ubuntu1) quantal; urgency=low

  * New upstream release
    - Update debian/patches/disable_usr_lib_install_rpath.diff for changes in
      this release

 -- Scott Kitterman <scott@kitterman.com>  Tue, 12 Jun 2012 09:19:05 -0400

soprano (2.7.56+dfsg.1-0ubuntu2) quantal; urgency=low

  * update libsoprano4.symbols for powerpc, armel, armhf

 -- Philip Muškovac <yofel@kubuntu.org>  Thu, 07 Jun 2012 23:35:21 +0200

soprano (2.7.56+dfsg.1-0ubuntu1) quantal; urgency=low

  * New upstream beta release
    - refresh disable_usr_lib_install_rpath.diff 
      and doxyfile_generate_tagfile.diff 
    - refresh libsoprano4.symbols and drop the symbols for TcpClient
      which was removed

 -- Philip Muškovac <yofel@kubuntu.org>  Sun, 03 Jun 2012 20:31:26 +0200

soprano (2.7.5+dfsg.1-1ubuntu1) quantal; urgency=low

  * Merge with Debian unstable, remaining changes:
    - Build-depend on libraptor2-dev instead of libraptor1-dev
    - Use Ubuntu version numbers in debian/libsoprano4.symbols
    - Do not apply redland_raptor2_support.h, no longer needed.

 -- Jonathan Thomas <echidnaman@kubuntu.org>  Sun, 20 May 2012 14:29:28 -0400

=== debian/rules ===
#!/usr/bin/make -f

builddir = Build

dh = --builddirectory=$(builddir)

include /usr/share/pkg-kde-tools/qt-kde-team/2/debian-qt-kde.mk

override_dh_auto_configure:
	$(overridden_command) -- -DSOPRANO_BUILD_API_DOCS=ON \
		-DSOPRANO_DISABLE_SESAME2_BACKEND=ON

override_dh_install:
	$(overridden_command) -plibsoprano-doc --sourcedir=$(builddir)
	$(overridden_command) --remaining-packages

override_dh_makeshlibs:
	$(overridden_command) -V

override_dh_shlibdeps:
	$(overridden_command) -psoprano-daemon -- -xlibsoprano4
	$(overridden_command) --remaining-packages

override_dh_strip:
	$(overridden_command) --dbg-package=libsoprano-dbg

prune-nonfree:
	# Deleting binary blobs
	find \( -name *.jar -o -name *.class \) -print -delete

## soprano 2.9.0+dfsg.1

=== server/CMakeLists.txt ===
project(soprano_server)

include_directories(
  ${soprano_server_BINARY_DIR}
  ${soprano_core_SOURCE_DIR}
  ${soprano_core_BINARY_DIR}
  ${soprano_core_SOURCE_DIR}/util
  ${soprano_core_SOURCE_DIR}/query
  ${soprano_core_SOURCE_DIR}/vocabulary
  ${QT_INCLUDES}
  ${soprano_SOURCE_DIR}
)

set(soprano_server_SRC
  servercore.h
  servercore.cpp
  serverconnection.h
  serverconnection.cpp
  serverdatastream.cpp
  modelpool.cpp
  randomgenerator.cpp
  localserver.cpp
  tcpserver.cpp
)

if(BUILD_DBUS_SUPPORT)
  set(soprano_server_SRC
    ${soprano_server_SRC}
    dbus/dbusutil.cpp
    dbus/dbusmodeladaptor.cpp
    dbus/dbusexportiterator.cpp
    dbus/dbusexportmodel.cpp
    dbus/dbusstatementiteratoradaptor.cpp
    dbus/dbusnodeiteratoradaptor.cpp
    dbus/dbusqueryresultiteratoradaptor.cpp
    dbus/dbusserveradaptor.cpp
    dbus/dbuscontroller.cpp
    dbus/dbusoperators.cpp
    )
endif(BUILD_DBUS_SUPPORT)

configure_file(soprano-server-config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/soprano-server-config.h)

#set(soprano_serverbackend_SRC
#  serverbackend.h
#  serverbackend.cpp
#)
  
qt4_automoc(${soprano_server_SRC})

#qt4_automoc(${soprano_serverbackend_SRC})

add_library(sopranoserver ${LIBRARY_TYPE} ${soprano_server_SRC})
#add_library(soprano_serverclientbackend SHARED ${soprano_serverbackend_SRC})

qt4_automoc(sopranodcore.cpp)

add_executable(sopranod sopranod.cpp sopranodcore.cpp lockfile.cpp)

if(WINCE)
    target_link_libraries(sopranod Coredll)
endif(WINCE)

set_target_properties(sopranoserver PROPERTIES
  VERSION 1.2.0
  SOVERSION 1
  DEFINE_SYMBOL MAKE_SOPRANO_SERVER_LIB
  INSTALL_NAME_DIR ${LIB_DESTINATION}
)

target_link_libraries(
  sopranoserver
  ${QT_QTCORE_LIBRARY}
  ${QT_QTNETWORK_LIBRARY}
  soprano
)
if(BUILD_DBUS_SUPPORT)
  target_link_libraries(
    sopranoserver
    ${QT_QTDBUS_LIBRARY})
endif(BUILD_DBUS_SUPPORT)


#target_link_libraries(
#  soprano_serverclientbackend
#  sopranoclient
#)

target_link_libraries(
  sopranod
  soprano
  sopranoserver
)

if(SOPRANO_BUILD_INDEX_LIB)
  target_link_libraries(
    sopranod
    sopranoindex
  )
endif(SOPRANO_BUILD_INDEX_LIB)

INSTALL(TARGETS sopranoserver sopranod
	LIBRARY DESTINATION ${LIB_DESTINATION}
	RUNTIME DESTINATION bin
	ARCHIVE DESTINATION lib
)

#INSTALL(TARGETS soprano_serverclientbackend
#	LIBRARY DESTINATION ${LIB_DESTINATION}/soprano
#	RUNTIME DESTINATION bin/soprano
#	ARCHIVE DESTINATION lib/soprano
#)

install(
  FILES 
  servercore.h
  DESTINATION include/soprano
)

if(BUILD_DBUS_SUPPORT)
  add_subdirectory(dbus)
endif(BUILD_DBUS_SUPPORT)

=== serializers/raptor/CMakeLists.txt ===
project(soprano_raptor_serializer)

include_directories(
  ${QT_QTCORE_INCLUDE_DIR}
  ${soprano_SOURCE_DIR}
  ${QT_INCLUDE_DIR}
  ${soprano_core_SOURCE_DIR}
  ${soprano_raptor_serializer_BINARY_DIR}
  ${RAPTOR_INCLUDE_DIR}
)

set(CMAKE_REQUIRED_INCLUDES ${RAPTOR_INCLUDE_DIR})
set(CMAKE_REQUIRED_LIBRARIES ${RAPTOR_LIBRARIES})

set(raptor_serializer_SRC
  raptorserializer.cpp
)

qt4_automoc(${raptor_serializer_SRC})

add_library(soprano_raptorserializer MODULE ${raptor_serializer_SRC})

TARGET_LINK_LIBRARIES(soprano_raptorserializer soprano ${RAPTOR_LIBRARIES})

set_target_properties(soprano_raptorserializer PROPERTIES
  DEFINE_SYMBOL MAKE_RAPTORSERIALIZER_LIB
)

if(WIN32)
# RUNTIME and ARCHIVE are ignored when the library type is set to MODULE (cf. add_library above)
# so specify the bin directory explicitely. Only the .dll will be copied.
  INSTALL(TARGETS soprano_raptorserializer DESTINATION bin/soprano)
else(WIN32)
  INSTALL(TARGETS soprano_raptorserializer
    LIBRARY DESTINATION ${LIB_DESTINATION}/soprano
    RUNTIME DESTINATION bin/soprano
    ARCHIVE DESTINATION lib/soprano
    )
endif(WIN32)

configure_file(raptorserializer.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/raptorserializer.desktop)

INSTALL(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/raptorserializer.desktop
  DESTINATION share/soprano/plugins
  )

=== debian/changelog ===
soprano (2.9.0+dfsg.1-0ubuntu1) raring; urgency=low

  * New upstream release
    - Update symbols/install files
  * Make DFSG compliant

 -- Rohan Garg <rohangarg@kubuntu.org>  Wed, 02 Jan 2013 13:02:08 +0000

soprano (2.8.0+dfsg.1-0ubuntu2) raring; urgency=low

  * Disable lucene support. Obsoleted upstream.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Wed, 21 Nov 2012 00:08:17 +0000

=== debian/control ===
Source: soprano
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Sune Vuorela <debian@pusling.com>, Fathi Boudra <fabo@debian.org>, Modestas Vainius <modax@debian.org>
Build-Depends: debhelper (>= 7.4.15), cmake (>= 2.6.2), pkg-kde-tools (>= 0.12),
 dpkg-dev (>= 1.15.5), libclucene-dev (>= 0.9.21b), libqt4-dev (>= 4.5.3),
 libraptor2-dev (>= 2.0.4), librdf0-dev (>= 1.0.13),
 doxygen (>= 1.7.1), graphviz, libvirtodbc0, unixodbc-dev
Standards-Version: 3.9.3
Homepage: http://soprano.sourceforge.net
Vcs-Browser: http://git.debian.org/?p=pkg-kde/kde-req/soprano.git
Vcs-Git: git://git.debian.org/pkg-kde/kde-req/soprano.git

Package: soprano-daemon
Section: utils
Architecture: any
Depends: libvirtodbc0, ${shlibs:Depends}, ${misc:Depends}
Recommends: libsoprano4 (= ${binary:Version})
Suggests: virtuoso-minimal
Breaks: libsoprano4 (<< 2.3.0+dfsg.1-1), libsoprano-dev (<< 2.3.0+dfsg.1-1)
Replaces: libsoprano4 (<< 2.3.0+dfsg.1-1), libsoprano-dev (<< 2.3.0+dfsg.1-1)
Description: daemon for the Soprano RDF framework
 Soprano is a pluggable RDF storage, parsing, and serialization framework based
 on Qt 4. Soprano is targeted at desktop applications that need to store RDF
 data. Its API has been optimized for simplicity and ease of use, while its
 modular structure allows it to use various different RDF storage
 implementations as its backend.
 .
 This package contains the Soprano daemon, D-Bus service, parser plugins, and a
 storage plugin for the Redland RDF Application Framework. This package is not
 intended to be neither directly installed nor used by end users. It will be
 installed automatically whenever needed.

Package: libsoprano4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, soprano-daemon (= ${binary:Version})
Conflicts: libsoprano3
Replaces: libsoprano3
Description: libraries for the Soprano RDF framework
 Soprano is a pluggable RDF storage, parsing, and serialization framework based
 on Qt 4.  Soprano is targeted at desktop applications that need to store RDF
 data.  Its API has been optimized for simplicity and ease of use, while its
 modular structure allows it to use various different RDF storage
 implementations as its backend.
 .
 This package contains the Soprano core libraries, D-Bus service, parser
 plugins, and a storage plugin for the Redland RDF Application Framework.

Package: libsoprano-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libsoprano4 (= ${binary:Version})
Suggests: libsoprano-doc (= ${source:Version})
Breaks: libsoprano4 (<< 2.1.64+svn897713), soprano-daemon (<< 2.4.0.1+dfsg.1)
Replaces: libsoprano4 (<< 2.1.64+svn897713), soprano-daemon (<< 2.4.0.1+dfsg.1)
Description: development files for the Soprano RDF framework
 Soprano is a pluggable RDF storage, parsing, and serialization framework based
 on Qt 4.  Soprano is targeted at desktop applications that need to store RDF
 data.  Its API has been optimized for simplicity and ease of use, while its
 modular structure allows it to use various different RDF storage
 implementations as its backend.
 .
 This package contains development files for building software that uses the
 Soprano libraries.

Package: libsoprano-doc
Priority: extra
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: qt4-doc
Description: developer documentation for the Soprano RDF framework
 Soprano is a pluggable RDF storage, parsing, and serialization framework based
 on Qt 4.  Soprano is targeted at desktop applications that need to store RDF
 data.  Its API has been optimized for simplicity and ease of use, while its
 modular structure allows it to use various different RDF storage
 implementations as its backend.
 .
 This package contains documentation for software developers using the Soprano
 RDF framework.

Package: libsoprano-dbg
Priority: extra
Section: debug
Architecture: any
Depends: ${misc:Depends}, libsoprano4 (= ${binary:Version})
Description: debugging symbols for the Soprano RDF framework
 Soprano is a pluggable RDF storage, parsing, and serialization framework based
 on Qt 4.  Soprano is targeted at desktop applications that need to store RDF
 data.  Its API has been optimized for simplicity and ease of use, while its
 modular structure allows it to use various different RDF storage
 implementations as its backend.
 .
 This package contains debugging files used to investigate problems with
 binaries included in the Soprano packages.

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,8 @@
 
 override_dh_auto_configure:
 	$(overridden_command) -- -DSOPRANO_BUILD_API_DOCS=ON \
-		-DSOPRANO_DISABLE_SESAME2_BACKEND=ON
+		-DSOPRANO_DISABLE_SESAME2_BACKEND=ON \
+		-DSOPRANO_DISABLE_CLUCENE_INDEX=1
 
 override_dh_install:
 	$(overridden_command) -plibsoprano-doc --sourcedir=$(builddir)

## soprano 2.9.4+dfsg

=== debian/changelog ===
soprano (2.9.4+dfsg-5) unstable; urgency=medium

  * Team upload.

  [ Simon McVittie ]
  * Remove obsolete libraptor1-dev build-dependency (Closes: #854034).
    Build-depend on libraptor2-dev instead, which is what
    soprano-daemon actually uses.

 -- Pino Toscano <pino@debian.org>  Fri, 03 Feb 2017 12:51:43 +0100

soprano (2.9.4+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Update symbols files. (Closes: #807590)
  * Remove obsolete installgen file.
  * Bump Standards-Version to 3.9.8, no changes required.
  * Update Vcs-* fields.

 -- Pino Toscano <pino@debian.org>  Fri, 19 Aug 2016 22:08:33 +0200

soprano (2.9.4+dfsg-3) unstable; urgency=medium

  * Update symbols files from buildds logs (2.9.4+dfsg-2).
  * Update symbols files.

 -- Maximiliano Curia <maxy@debian.org>  Tue, 11 Aug 2015 08:55:00 +0200

soprano (2.9.4+dfsg-2) unstable; urgency=medium

  * Update symbols file with buildds logs.
  * Update symbols files. (Closes: #778126, #752112)

 -- Maximiliano Curia <maxy@debian.org>  Sun, 09 Aug 2015 21:15:54 +0200

soprano (2.9.4+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Update symbols file.
    Patch by Sphinx Jiang <yishanj13@gmail.com>.
    Work done for Debian GSOC2014.
    Closes: #746916.

 -- Anibal Monsalve Salazar <anibal@debian.org>  Tue, 24 Jun 2014 10:46:06 +0100

soprano (2.9.4+dfsg-1) unstable; urgency=low

  * New upstream release.
  * Update patch: add_library_architecture_to_libDirs.patch.
  * Remove patch: upstream_find-clucene-shared.diff, already applied by
    upstream.
  * Remove obsolete patch: x11_not_required.diff.
  * Refresh patches.

 -- Maximiliano Curia <maxy@debian.org>  Mon, 04 Nov 2013 16:10:56 +0100

soprano (2.9.3+dfsg-1) experimental; urgency=low

  * New upstream release.
  * New patch: add_library_architecture_to_libDirs.patch.

 -- Maximiliano Curia <maxy@debian.org>  Thu, 05 Sep 2013 17:25:16 +0200

soprano (2.9.2+dfsg.1-4) unstable; urgency=low

  * Team upload.
  * Remove last bits of multiarch, since soprano is not read for it and
    would require more work to also not break rdepends:
    - drop patch add_m-a_dirs_to_the_search_path.diff
    - remove Pre-Depends
  * Backport upstream commit 4bfdfdfdee03080ec9ca21eeb168c2ab9dbba0bb to fix
    compatibility with clucene 2.x; patch upstream_find-clucene-shared.diff.
    (Closes: #718369)
  * Update symbols file.

 -- Pino Toscano <pino@debian.org>  Tue, 06 Aug 2013 16:18:51 +0200

soprano (2.9.2+dfsg.1-3) experimental; urgency=low

  * Rebuild without multi-arch.
  * New patch, add m-a dirs to the search patch.

 -- Maximiliano Curia <maxy@debian.org>  Thu, 06 Jun 2013 13:10:19 +0200

soprano (2.9.2+dfsg.1-2) experimental; urgency=low

  * Rebuild for multi-arch.
  * Update install files.
  * Update vcs-fields.
  * Update lintian override for m-a.

 -- Maximiliano Curia <maxy@debian.org>  Thu, 06 Jun 2013 10:37:48 +0200

soprano (2.9.2+dfsg.1-1) unstable; urgency=low

  * New upstream release.
  * Disable x11_not_required.diff patch, applied by upstream.
  * Disable doxyfile_generate_tagfile.diff patch, applied by upstream.

 -- Maximiliano Curia <maxy@debian.org>  Sat, 11 May 2013 15:25:32 +0200

soprano (2.9.1+dfsg.1-1) unstable; urgency=low

  * New upstream release.

  [ Pino Toscano ]
  * Drop unused (since 2.9.0+dfsg1-1) patch disable_usr_lib_install_rpath.diff.

  [ Maximiliano Curia ]
  * Update watch file.
  * Bump Standards-Version to 3.9.4, no changes required.
  * Add myself to the list of uploaders.
  * Update symbols file:
    - Remove Soprano::Server::ServerCore::serverConnectionFinished() (private).
    - Add new symbols.

 -- Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Fri, 10 May 2013 01:24:13 +0200

soprano (2.9.0+dfsg1-1) experimental; urgency=low

  * New upstream release.

  [ José Manuel Santamaría Lema ]
  * Update symbols files.
  * Bump debhelper compatibility level to 9.
  * Remove dont_use_virtuoso_default_port.diff, applied upstream.
  * Update symbols files.
  * Update installed files.
  * Add lintian override for hardening-no-fortify-functions.

  [ Daniele E. Domenichelli ]
  * Update disable_usr_lib_install_rpath.diff.

  [ Sune Vuorela ]
  * Release to experimental
  * Update me in uploaders

 -- Sune Vuorela <sune@debian.org>  Mon, 25 Mar 2013 17:44:41 +0100

soprano (2.7.6+dfsg.1-3) unstable; urgency=low

  * Team upload.
  * Add dont_use_virtuoso_default_port.diff, prevents hangs when installing or
    running virtuoso as a standalone server.

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Tue, 05 Feb 2013 11:38:17 +0100

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,24 @@
 Source: soprano
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
-Uploaders: Sune Vuorela <debian@pusling.com>, Fathi Boudra <fabo@debian.org>, Modestas Vainius <modax@debian.org>
-Build-Depends: debhelper (>= 7.4.15), cmake (>= 2.6.2), pkg-kde-tools (>= 0.12),
+Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
+Uploaders: Sune Vuorela <sune@debian.org>,
+           Fathi Boudra <fabo@debian.org>,
+           Modestas Vainius <modax@debian.org>,
+           Maximiliano Curia <maxy@debian.org>
+Build-Depends: debhelper (>= 9), cmake (>= 2.6.2), pkg-kde-tools (>= 0.12),
  dpkg-dev (>= 1.15.5), libclucene-dev (>= 0.9.21b), libqt4-dev (>= 4.5.3),
- libraptor2-dev (>= 2.0.4), librdf0-dev (>= 1.0.13),
- doxygen (>= 1.7.1), graphviz, libvirtodbc0, unixodbc-dev
-Standards-Version: 3.9.3
+ libraptor2-dev (>= 1.4.16), librdf0-dev (>= 1.0.13),
+ doxygen (>= 1.7.1), graphviz, libiodbc2-dev
+Standards-Version: 3.9.8
 Homepage: http://soprano.sourceforge.net
-Vcs-Browser: http://git.debian.org/?p=pkg-kde/kde-req/soprano.git
-Vcs-Git: git://git.debian.org/pkg-kde/kde-req/soprano.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-req/soprano.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-kde/kde-req/soprano.git
 
 Package: soprano-daemon
 Section: utils
 Architecture: any
-Depends: libvirtodbc0, ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: libsoprano4 (= ${binary:Version})
 Suggests: virtuoso-minimal
 Breaks: libsoprano4 (<< 2.3.0+dfsg.1-1), libsoprano-dev (<< 2.3.0+dfsg.1-1)
@@ -71,6 +73,8 @@
 Architecture: all
 Depends: ${misc:Depends}
 Recommends: qt4-doc
+Breaks: libsoprano-dev (<< 2.6.0+dfsg.1-1)
+Replaces: libsoprano-dev (<< 2.6.0+dfsg.1-1)
 Description: developer documentation for the Soprano RDF framework
  Soprano is a pluggable RDF storage, parsing, and serialization framework based
  on Qt 4.  Soprano is targeted at desktop applications that need to store RDF

=== debian/watch ===
version=3

opts=dversionmangle=s/~/-/;s/[\.\+]dfsg[\d\.]*// \
http://sf.net/soprano/soprano-(.*)\.tar\.bz2
